
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">


<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    
    <title>Preliminaries</title>
    
    <link rel="stylesheet" href="_static/basic.css" type="text/css" />
    <link rel="stylesheet" href="_static/pygments.css" type="text/css" />
    <link rel="stylesheet" href="_static/custom.css" type="text/css" />
    <link rel="stylesheet" href="_static/bootstrap-sphinx.css" type="text/css" />
    
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    './',
        VERSION:     '1.6',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true
      };
    </script>
    <script type="text/javascript" src="_static/jquery.js"></script>
    <script type="text/javascript" src="_static/underscore.js"></script>
    <script type="text/javascript" src="_static/doctools.js"></script>
    <script type="text/javascript" src="https://cdn.mathjax.org/mathjax/latest/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>
    <script type="text/javascript" src="_static/bootstrap-sphinx.js"></script>
    <link rel="top" title="The FEniCS Tutorial Volume I" href="index.html" />
    <link rel="next" title="Fundamentals: Solving the Poisson equation" href="._ftut1003.html" />
    <link rel="prev" title="Preface" href="._ftut1001.html" />
  <meta charset='utf-8'>
  <meta http-equiv='X-UA-Compatible' content='IE=edge,chrome=1'>
  <meta name='viewport' content='width=device-width, initial-scale=1.0, maximum-scale=1'>
  <meta name="apple-mobile-web-app-capable" content="yes">

  <!-- Default Bootstrap-->
  <link rel="stylesheet" href="_static/css/bootstrap.min.css"/>
  <link rel="shortcut icon" href="_static/fenics.ico" />
  <!-- Template styles CSS-->
  <link rel="stylesheet" href="_static/css/main.css"/>
  <link rel="stylesheet" href="_static/css/custom.css"/>
  <link rel="stylesheet" href="_static/css/font-awesome.min.css"/>
  <link rel="stylesheet" href="_static/css/animate.min.css"/>
  <link rel="stylesheet" href="_static/css/responsive.css"/>

  <!-- Template styles JS-->
  <script src="_static/slides.min.jquery.js"></script>
  <script type="text/javascript" src="_static/js/jquery-1.11.0.min.js"></script>
  <script type="text/javascript" src="_static/js/jquery-fix.js"></script>
  <script type="text/javascript" src="_static/js/bootstrap.js"></script>
  <script type="text/javascript" src="_static/js/bootstrap.min.js"></script>
  <script type="text/javascript" src="_static/js/wow.min.js"></script>
  <script type="text/javascript" src="_static/js/main.js"></script>
  <script type="text/javascript" src="_static/js/jquery.bcSwipe.js"></script>
  <script>
    $(document).ready(function() {
         $("#mycarousel").swiperight(function() {
            $(this).carousel('prev');
            });
         $("#mycarousel").swipeleft(function() {
            $(this).carousel('next');
       });
    });
  </script>

  
       <style type="text/css">
         div.admonition {
           background-color: whiteSmoke;
           border: 1px solid #bababa;
         }
       </style>
      </head>
    
  <body role="document">
<header id="header">
      <div class="navbar navbar-inverse" role="banner">
          <div class="container">
              <div class="navbar-header">
                  <button type="button" class="navbar-toggle" data-toggle="collapse" data-target="#headernavbar">
                      <span class="sr-only">Toggle navigation</span>
                      <span class="icon-bar"></span>
                      <span class="icon-bar"></span>
                      <span class="icon-bar"></span>
                  </button>

                  <a class="navbar-brand" href="http://fenicsproject.org/index.html">
                      <h1><img src="_static/fenics_banner.png" alt="FEniCS Project Logo" class="img-responsive center-block banner-image"></h1>
                  </a>

              </div>
              <div class="collapse navbar-collapse" id="headernavbar">
                <ul class="nav navbar-nav navbar-right">
                    <li><a href="._ftut1001.html" title="Previous page">Prev</a></li>
                    <li><a href="._ftut1003.html" title="Next page">Next</a></li>
                    <li class="page_item"><a href="http://fenicsproject.org/index.html">Home</a></li>
                    <li class="page_item"><a href="http://fenicsproject.org/about/" title="Find out more about the FEniCS project">About</a></li>
                    <li class="page_item"><a href="http://fenicsproject.org/download/" title="Obtain the FEniCS project">Download</a></li>
                    <li class="page_item"><a href="http://fenicsproject.org/documentation/" title="Learn how to use the FEniCS project">Documentation</a></li>
                    <li class="page_item"><a href="http://fenicsproject.org/contributing/" title="Learn how to contribute to the FEniCS project">Contributing</a></li>
                    <li class="page_item"><a href="http://fenicsproject.org/citing/" title="Learn how to cite the FEniCS project">Citing</a></li>
                    <li class="page_item"><a href="http://fenicsproject.org/support/" title="Where to go for more help">Support</a></li>
                  </ul>
              </div>
          </div>
      </div>
  </header>

<div class="container">
  <div class="row">
    <div class="col-md-12">
      
  <div class="section" id="preliminaries">
<span id="ch-prelim"></span><h1>Preliminaries<a class="headerlink" href="#preliminaries" title="Permalink to this headline">¶</a></h1>
<div class="section" id="the-fenics-project">
<h2>The FEniCS Project<a class="headerlink" href="#the-fenics-project" title="Permalink to this headline">¶</a></h2>
<p>The FEniCS Project is a research and software project aimed at
creating mathematical methods and software for automated computational
mathematical modeling. This means creating easy, intuitive, efficient,
and flexible software for solving partial differential equations
(PDEs) using finite element methods. FEniCS was initially created in
2003 and is developed in collaboration between researchers from a
number of universities and research institutes around the world. For
more information about FEniCS and the latest updates of the FEniCS
software and this tutorial, visit the FEniCS web page at
<code class="docutils literal"><span class="pre">https://fenicsproject.org</span></code>.</p>
<span class="target" id="index-0"></span><span class="target" id="index-1"></span><span class="target" id="index-2"></span><span class="target" id="index-3"></span><span class="target" id="index-4"></span><p id="index-5">FEniCS consists of a number of building blocks (software components)
that together form the FEniCS software: DOLFIN <a class="reference internal" href="._ftut1006.html#ref02" id="id1">[Ref02]</a>, FFC
<a class="reference internal" href="._ftut1006.html#ref03" id="id2">[Ref03]</a>, FIAT <a class="reference internal" href="._ftut1006.html#ref04" id="id3">[Ref04]</a>, UFL <a class="reference internal" href="._ftut1006.html#ref05" id="id4">[Ref05]</a>, mshr,
and a few others. For an overview, see <a class="reference internal" href="._ftut1006.html#ref01" id="id5">[Ref01]</a>.
FEniCS users rarely need to think about this
internal organization of FEniCS, but since even casual users may
sometimes encounter the names of various FEniCS components, we briefly
list the components and their main roles in FEniCS. DOLFIN is the
computational high-performance C++ backend of FEniCS. DOLFIN
implements data structures such as meshes, function spaces and
functions, compute-intensive algorithms such as finite element
assembly and mesh refinement, and interfaces to linear algebra solvers
and data structures such as PETSc. DOLFIN also implements the FEniCS
problem-solving environment in both C++ and Python. FFC is the code
generation engine of FEniCS (the form compiler), responsible for
generating efficient C++ code from high-level mathematical
abstractions. FIAT is the finite element backend of FEniCS,
responsible for generating finite element basis functions, UFL
implements the abstract mathematical language by which users may
express variational problems, and mshr provides FEniCS with
mesh generation capabilities.</p>
</div>
<div class="section" id="what-you-will-learn">
<h2>What you will learn<a class="headerlink" href="#what-you-will-learn" title="Permalink to this headline">¶</a></h2>
<p>The goal of this tutorial is to demonstrate how to apply the
finite element to solve PDEs in FEniCS. Through a series of
examples, we demonstrate how to:</p>
<blockquote>
<div><ul class="simple">
<li>solve linear PDEs (such as the Poisson equation),</li>
<li>solve time-dependent PDEs (such as the heat equation),</li>
<li>solve nonlinear PDEs,</li>
<li>solve systems of time-dependent nonlinear PDEs.</li>
</ul>
</div></blockquote>
<p>Important topics involve how to set boundary conditions of various
types (Dirichlet, Neumann, Robin), how to create meshes, how to
define variable coefficients, how to interact with linear and
nonlinear solvers, and how to postprocess and visualize solutions.</p>
<p>We will also discuss how to best structure the Python code for
a PDE solver, how to debug programs, and how to take advantage
of testing frameworks.</p>
</div>
<div class="section" id="working-with-this-tutorial">
<h2>Working with this tutorial<a class="headerlink" href="#working-with-this-tutorial" title="Permalink to this headline">¶</a></h2>
<p>The mathematics of the illustrations is kept simple to better focus on
FEniCS functionality and syntax. This means that we mostly use the
Poisson equation and the time-dependent diffusion equation as model
problems, often with input data adjusted such that we get a very
simple solution that can be exactly reproduced by any standard finite
element method over a uniform, structured mesh. This latter property
greatly simplifies the verification of the implementations.
Occasionally we insert a physically more relevant example to remind
the reader that the step from solving a simple model problem to a
challenging real-world problem is often quite short and easy with FEniCS.</p>
<p>Using FEniCS to solve PDEs may seem to require a thorough
understanding of the abstract mathematical framework of the finite
element method as well as expertise in Python programming.
Nevertheless, it turns out that many users are able to pick up the
fundamentals of finite elements <em>and</em> Python programming as they go
along with this tutorial. Simply keep on reading and try out the
examples. You will be amazed at how easy it is to solve PDEs with
FEniCS!</p>
</div>
<div class="section" id="obtaining-the-software">
<h2>Obtaining the software<a class="headerlink" href="#obtaining-the-software" title="Permalink to this headline">¶</a></h2>
<p>Working with this tutorial obviously requires access to the FEniCS
software. FEniCS is a complex software library, both in itself and due
to its many dependencies to state-of-the-art open-source scientific
software libraries. Manually building FEniCS and all its dependencies
from source can thus be a daunting task. Even for an expert who knows
exactly how to configure and build each component, a full build can
literally take hours! In addition to the complexity of the software
itself, there is an additional layer of complexity in how many
different kinds of operating systems (Linux, Mac, Windows)
may be running on a user&#8217;s laptop or compute server, with
different requirements for how to configure and build software.</p>
<span class="target" id="index-6"></span><span class="target" id="index-7"></span><span class="target" id="index-8"></span><span class="target" id="index-9"></span><p id="index-10">For this reason, the FEniCS Project provides prebuilt packages to make
the installation easy, fast, and foolproof.</p>
<div class="admonition-fenics-download-and-installation admonition">
<p class="first admonition-title">FEniCS download and installation</p>
<p>In this tutorial, we highlight two main options for installing the
FEniCS software: Docker containers and Ubuntu packages. While the
Docker containers work on all operating systems, the Ubuntu packages
only work on Ubuntu-based systems. Note that the built-in FEniCS
plotting does currently not work from Docker, although rudimentary
plotting is supported via the Docker Jupyter notebook option.</p>
<p class="last">FEniCS may also be installed using other methods, including Conda
packages and building from source. For more installation options and
the latest information on the simplest and best options for installing
FEniCS, check out the official FEniCS installation instructions. These
can be found at
<a class="reference external" href="https://fenicsproject.org/download">https://fenicsproject.org/download</a>.</p>
</div>
<div class="admonition-fenics-version-2016-2 admonition">
<p class="first admonition-title">FEniCS version: 2016.2</p>
<p class="last">FEniCS versions are labeled 2016.1, 2016.2, 2017.1 and so on,
where the major number indicates the year of release and the
minor number is a counter starting at 1. The number of releases
per year varies but typically one can expect 2 - 3 releases per
year. This tutorial was prepared for and tested with FEniCS
version 2016.2.</p>
</div>
<div class="section" id="installation-using-docker-containers">
<span id="index-11"></span><h3>Installation using Docker containers<a class="headerlink" href="#installation-using-docker-containers" title="Permalink to this headline">¶</a></h3>
<p id="index-12">A modern solution to the challenge of software installation on diverse
software platforms is to use so-called <em>containers</em>. The FEniCS
Project provides custom-made containers that are controlled,
consistent, and high-performance software environments for FEniCS
programming. FEniCS containers work equally well <a class="footnote-reference" href="#dockerperformance" id="id6">[1]</a>
on all operating systems, including Linux, Mac, and Windows.</p>
<span class="target" id="index-13"></span><span class="target" id="index-14"></span><table class="docutils footnote" frame="void" id="dockerperformance" rules="none">
<colgroup><col class="label" /><col /></colgroup>
<tbody valign="top">
<tr><td class="label"><a class="fn-backref" href="#id6">[1]</a></td><td>Running Docker containers on Mac and Windows
involves a small performance overhead compared to running Docker
containers on Linux. However, this performance penalty is typically
small and is often compensated for by using the highly tuned and
optimized version of FEniCS that comes with the official FEniCS
containers, compared to building FEniCS and its dependencies from
source on Mac or Windows.</td></tr>
</tbody>
</table>
<p>To use FEniCS containers, you must first install the Docker
platform. Docker installation is simple and instructions are available
on the <a class="reference external" href="https://www.docker.com">Docker web page</a>. Once you have installed
Docker, just copy the following line into a
terminal window:</p>
<div class="highlight-text"><div class="highlight"><pre><span></span>Terminal&gt; curl -s https://get.fenicsproject.org | bash
</pre></div>
</div>
<p>The command above will install the program <code class="docutils literal"><span class="pre">fenicsproject</span></code> on your
system. This program lets you easily create FEniCS sessions
(containers) on your system:</p>
<div class="highlight-text" id="index-15"><div class="highlight"><pre><span></span>Terminal&gt; fenicsproject run
</pre></div>
</div>
<p>This command has several useful options, such as easily switching
between the latest release of FEniCS, the latest development version
and many more. To learn more, type <code class="docutils literal"><span class="pre">fenicsproject</span> <span class="pre">help</span></code>. FEniCS can
also be used directly with Docker, but this typically requires
typing a relatively complex Docker command, for example:</p>
<div class="highlight-text"><div class="highlight"><pre><span></span>docker run --rm -ti -v `pwd`:/home/fenics/shared -w
/home/fenics/shared quay.io/fenicsproject/stable:current &#39;/bin/bash -l
-c &quot;export TERM=xterm; bash -i&quot;&#39;
</pre></div>
</div>
<div class="admonition-sharing-files-with-fenics-containers admonition">
<p class="first admonition-title">Sharing files with FEniCS containers</p>
<p class="last">When you run a FEniCS session using <code class="docutils literal"><span class="pre">fenicsproject</span> <span class="pre">run</span></code>, it will
automatically share your current working directory (the directory
from which you run the <code class="docutils literal"><span class="pre">fenicsproject</span></code> command) with the FEniCS
session. When the FEniCS session starts, it will automatically
enter into a directory named <code class="docutils literal"><span class="pre">shared</span></code> which will be identical with
your current working directory on your host system. This means that
you can easily edit files and write data inside the FEniCS session, and
the files will be directly accessible on your host system. It is
recommended that you edit your programs using your favorite editor
(such as Emacs or Vim) on your host system and use the FEniCS session
only to run your program(s).</p>
</div>
<span class="target" id="index-16"></span><span class="target" id="index-17"></span></div>
<div class="section" id="installation-using-ubuntu-packages">
<span id="index-18"></span><h3>Installation using Ubuntu packages<a class="headerlink" href="#installation-using-ubuntu-packages" title="Permalink to this headline">¶</a></h3>
<p>For users of Ubuntu GNU/Linux, FEniCS can also be installed easily via
the standard Ubuntu package manager <code class="docutils literal"><span class="pre">apt-get</span></code>. Just copy the following
lines into a terminal window:</p>
<span class="target" id="index-19"></span><span class="target" id="index-20"></span><div class="highlight-text" id="index-21"><div class="highlight"><pre><span></span>Terminal&gt; sudo add-apt-repository ppa:fenics-packages/fenics
Terminal&gt; sudo apt-get update
Terminal&gt; sudo apt-get install fenics
Terminal&gt; sudo apt-get dist-upgrade
</pre></div>
</div>
<p>This will add the FEniCS package archive (PPA) to your Ubuntu
computer&#8217;s list of software sources and then install FEniCS. It will
will also automatically install packages for dependencies of FEniCS.</p>
<div class="admonition-watch-out-for-old-packages admonition">
<p class="first admonition-title">Watch out for old packages</p>
<p class="last">In addition to being available from the FEniCS PPA, the FEniCS
software is also part of the official Ubuntu repositories. However,
depending on which release of Ubuntu you are running, and when this
release was created in relation to the latest FEniCS release, the
official Ubuntu repositories might contain an outdated version of
FEniCS. For this reason, it is better to install from the FEniCS PPA.</p>
</div>
</div>
<div class="section" id="testing-your-installation">
<h3>Testing your installation<a class="headerlink" href="#testing-your-installation" title="Permalink to this headline">¶</a></h3>
<p>Once you have installed FEniCS, you should make a quick test to see
that your installation works properly. To do this, type the following
command in a FEniCS-enabled <a class="footnote-reference" href="#dockerreminder" id="id7">[2]</a> terminal:</p>
<table class="docutils footnote" frame="void" id="dockerreminder" rules="none">
<colgroup><col class="label" /><col /></colgroup>
<tbody valign="top">
<tr><td class="label"><a class="fn-backref" href="#id7">[2]</a></td><td>For users of FEniCS containers, this means first
running the command <code class="docutils literal"><span class="pre">fenicsproject</span> <span class="pre">run</span></code>.</td></tr>
</tbody>
</table>
<div class="highlight-text"><div class="highlight"><pre><span></span>Terminal&gt; python -c &#39;import fenics&#39;
</pre></div>
</div>
<p>If all goes well, you should be able to run this command without any
error message (or any other output).</p>
</div>
</div>
<div class="section" id="obtaining-the-tutorial-examples">
<h2>Obtaining the tutorial examples<a class="headerlink" href="#obtaining-the-tutorial-examples" title="Permalink to this headline">¶</a></h2>
<p>In this tutorial, you will learn finite element and FEniCS programming
through a number of example programs that demonstrate both how to
solve particular PDEs using the finite element method, how to program
solvers in FEniCS, and how to create well-designed Python code that
can later be extended to solve more complex problems. All
example programs are available from the web page of this book at
<code class="docutils literal"><span class="pre">https://fenicsproject.org/tutorial</span></code>. The programs as well as the
source code for this text can also be accessed directly from the <a class="reference external" href="https://github.com/hplgit/fenics-tutorial/">Git
repository</a> for this
book.</p>
</div>
<div class="section" id="background-knowledge">
<span id="index-22"></span><h2>Background knowledge<a class="headerlink" href="#background-knowledge" title="Permalink to this headline">¶</a></h2>
<div class="section" id="programming-in-python">
<span id="ftut-pybooks"></span><h3>Programming in Python<a class="headerlink" href="#programming-in-python" title="Permalink to this headline">¶</a></h3>
<p>While you can likely pick up basic Python programming by working
through the examples in this tutorial, you may want to study
additional material on the Python language. A natural starting point
for beginners is the classic <em>Python Tutorial</em> <a class="reference internal" href="._ftut1006.html#ref06" id="id8">[Ref06]</a>,
or a tutorial geared towards scientific computing
<a class="reference internal" href="._ftut1006.html#ref07" id="id9">[Ref07]</a>.  In the latter, you will also find
pointers to other tutorials for scientific computing in Python. Among
ordinary books we recommend the general introduction <em>Dive into
Python</em> <a class="reference internal" href="._ftut1006.html#ref08" id="id10">[Ref08]</a> as well as texts that focus on scientific
computing with Python
<a class="reference internal" href="._ftut1006.html#ref09" id="id11">[Ref09]</a> <a class="reference internal" href="._ftut1006.html#ref10" id="id12">[Ref10]</a> <a class="reference internal" href="._ftut1006.html#ref11" id="id13">[Ref11]</a> <a class="reference internal" href="._ftut1006.html#ref12" id="id14">[Ref12]</a> <a class="reference internal" href="._ftut1006.html#ref13" id="id15">[Ref13]</a>.</p>
<div class="admonition-python-versions admonition" id="index-23">
<p class="first admonition-title">Python versions</p>
<p>Python comes in two versions, 2 and 3, and these are not compatible.
FEniCS works with both versions of Python. All the
programs in this tutorial are also developed such that they can be run
under both Python 2 and 3. Python programs that need to print must
then start with</p>
<div class="highlight-python"><div class="highlight"><pre><span></span><span class="kn">from</span> <span class="nn">__future__</span> <span class="kn">import</span> <span class="n">print_function</span>
</pre></div>
</div>
<p class="last">to  enable the <code class="docutils literal"><span class="pre">print</span></code> function from Python 3 in Python 2. All
use of <code class="docutils literal"><span class="pre">print</span></code> in the programs in this tutorial consists of function
calls, like <code class="docutils literal"><span class="pre">print('a:',</span> <span class="pre">a)</span></code>. Almost all other constructions are of
a form that looks the same in Python 2 and 3.</p>
</div>
</div>
<div class="section" id="the-finite-element-method">
<span id="ftut-fembooks"></span><h3>The finite element method<a class="headerlink" href="#the-finite-element-method" title="Permalink to this headline">¶</a></h3>
<p id="index-24">Many good books have been written on the finite element method. The
books typically fall in either of two categories: the abstract
mathematical version of the method or the engineering &#8220;structural
analysis&#8221; formulation. FEniCS builds heavily on concepts from the
abstract mathematical exposition. The first author has
a <a class="reference external" href="http://hplgit.github.io/fem-book/doc/web/index.html">book</a>
<a class="reference internal" href="._ftut1006.html#ref14" id="id16">[Ref14]</a> in development that
explains all details of the finite element method in an intuitive way,
using the abstract mathematical formulations that FEniCS employs.</p>
<p>The finite element text by Larson and Bengzon <a class="reference internal" href="._ftut1006.html#ref15" id="id17">[Ref15]</a>
is our recommended introduction to the finite element method,
with a mathematical notation that goes well with FEniCS.
An easy-to-read book, which also provides a good general background for
using FEniCS, is Gockenbach <a class="reference internal" href="._ftut1006.html#ref16" id="id18">[Ref16]</a>. The book by Donea
and Huerta <a class="reference internal" href="._ftut1006.html#ref17" id="id19">[Ref17]</a> has a similar style, but aims at
readers with an interest in fluid flow problems. Hughes <a class="reference internal" href="._ftut1006.html#ref18" id="id20">[Ref18]</a>
is also recommended, especially for readers interested in solid
mechanics and heat transfer applications.</p>
<p>Readers with a background in the engineering &#8220;structural analysis&#8221;
version of the finite element method may find Bickford
<a class="reference internal" href="._ftut1006.html#ref19" id="id21">[Ref19]</a> an attractive bridge over to the abstract
mathematical formulation that FEniCS builds upon. Those who have a
weak background in differential equations in general should consult a
more fundamental book, and Eriksson <em>et al</em>
<a class="reference internal" href="._ftut1006.html#ref20" id="id22">[Ref20]</a> is a very good choice. On the
other hand, FEniCS users with a strong background in mathematics
will appreciate the texts by Brenner and Scott <a class="reference internal" href="._ftut1006.html#ref21" id="id23">[Ref21]</a>,
Braess <a class="reference internal" href="._ftut1006.html#ref22" id="id24">[Ref22]</a>, Ern and Guermond <a class="reference internal" href="._ftut1006.html#ref23" id="id25">[Ref23]</a>,
Quarteroni and Valli <a class="reference internal" href="._ftut1006.html#ref24" id="id26">[Ref24]</a>, or Ciarlet
<a class="reference internal" href="._ftut1006.html#ref25" id="id27">[Ref25]</a>.</p>
</div>
</div>
</div>


    </div>
  </div>
</div>
 <script type="text/javascript">
    $(document).ready(function() {
        $(".toggle > *").hide();
        $(".toggle .header").show();
        $(".toggle .header").click(function() {
            $(this).parent().children().not(".header").toggle(400);
            $(this).parent().children(".header").toggleClass("open");
        })
    });
</script>

  </body>
</html>